<template>
  <div class="home">
    <b-button v-b-modal.modal-join>Join a Game</b-button>

    <b-modal
      id="modal-join"
      title="Join a Game"
      @show="resetModal"
      @hidden="resetModal"
      @ok="handleOk"
    >
      <form ref="joinForm" @submit.stop.prevent="handleSubmit">
        <b-form-group
          horizontal
          :label-cols="4"
          :state="idState"
          description="Get ID from the game master."
          label="Enter game ID"
          invalid-feedback="Name is required"
        >
          <b-form-input v-model.trim="id" :state="idState" required></b-form-input>
        </b-form-group>
        <b-form-group
          horizontal
          :label-cols="4"
          :state="nameState"
          description="Let us know your name."
          label="Enter your name"
          invalid-feedback="Name is required"
        >
          <b-form-input v-model.trim="name" :state="nameState" required></b-form-input>
        </b-form-group>
      </form>
    </b-modal>

    <b-alert variant="success" :show="showAlert">Hello {{ name }}</b-alert>
  </div>
</template>

<script>
import * as fb from "@/firebase";

export default {
  data() {
    return {
      id: "",
      idState: null,
      name: "",
      nameState: null
    };
  },
  computed: {
    showAlert() {
      return this.name.length > 4 ? true : false;
    }
  },
  methods: {
    checkFormValidity() {
      const valid = this.$refs.joinForm.checkValidity();
      this.nameState = valid;
      return valid;
    },
    resetModal() {
      this.id = "";
      this.idState = null;
      this.name = "";
      this.nameState = null;
    },
    handleOk(bvModalEvt) {
      // Prevent modal from closing
      bvModalEvt.preventDefault();
      // Trigger submit handler
      this.handleSubmit();
    },
    handleSubmit() {
      // Exit when the form isn't valid
      if (!this.checkFormValidity()) {
        return;
      }

      fb.db
        .collection("games")
        .doc(this.id)
        .update({
          players: fb.firebase.firestore.FieldValue.arrayUnion(this.name)
        })
        .then(() => {
          this.$bvModal.hide("modal-join");
          this.$router.push({ name: "Game", params: { id: this.id } });
        });
    }
  }
};
</script>
